function [newsig]=preemph(signal,coeff)
%[newsig]=preemph(signal,coeff)
% 
%PREEMPH -- Preemphasis Filtering and Normalization
%
% This function applies the simple high pass kernel
%   newsig(i) = signal(i)-coeff*signal(i-1);
%
% the boundary condition is dealt with by newsig(1)=signal(1)*(1-coeff);
%
% if signal is a matrix then the pre-emphasis is applied to each column

assert(coeff<1 & coeff>0);
[r,c] = size(signal);
if (r==1) flip=1; signal=signal'; [r,c]=size(signal); else flip=0; end

newsig=zeros(size(signal));
for i=1:c
  newsig(2:r,i) = signal(2:r,i) - coeff*signal(1:(r-1),i);
end
newsig(1,:) = signal(1,:)*(1-coeff); %do not discard the first sample

if(flip==1) newsig=newsig'; end




